/*
*  Name:      test-3.uesql.cc
*  Author:    Rafael Jesus Alcantara Perez
*  Summary:   Exhaustive test for UESQL
*  Date:      $Date: 2003/06/22 14:35:38 $
*  Revision:  $Revision: 1.1 $
*
*  Copyright (C) 1996-2001  Rafael Jesus Alcantara Perez <rafa@dedalo-ing.com>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
*  MA 02111-1307, USA.
*/

/*
*  I have had to substitute the field named C by another name to
*  avoid collision with NRW_C.
*
*  --  ::=  Compiler error
*  --- ::=  Sentence error
*
*/


///  Main.
int main (void)
{

extern "UESQL::default" {

  CREATE VIEW SET_TEST (EMP1, EMP_AVG, EMP_MAX) AS
    SELECT EMPNUM, AVG(HOURS), MAX(HOURS)
    FROM STAFF, WORKS
    GROUP BY EMPNUM;

  CREATE VIEW SET_TEST (EMP1, EMP_AVG, EMP_MAX) AS
    SELECT SCHEME1.STAFF.EMPNUM, AVG(HOURS), MAX(HOURS)
    FROM STAFF, WORKS
    GROUP BY SCHEME1.STAFF.EMPNUM;

  CREATE VIEW SET_TEST (EMP1, EMP_AVG, EMP_MAX) AS
    SELECT STAFF.EMPNUM, AVG(HOURS), MAX(HOURS)
    FROM STAFF, WORKS
    GROUP BY STAFF.EMPNUM;

  CREATE TABLE HU.ECCO (C1 CHAR(2));
  
SELECT A INTO :A FROM B WHERE A LIKE "B";
SELECT A INTO :A FROM B WHERE A NOT LIKE "B";
SELECT ALL A INTO :A FROM B;
SELECT DISTINCT A INTO :A FROM B;
SELECT A INTO :A FROM B;
SELECT (A + Z) INTO :A FROM B;
SELECT (A - B)*Z INTO :A FROM D;

CREATE ASSERTION ASSERTION_1
      CHECK
        ( NOT EXISTS
          ( SELECT * FROM
              TABLE_CONSTRAINTS
              FULL OUTER JOIN
                KEY_COLUMN_USAGE
                  USING ( CONSTRAINT_CATALOG, CONSTRAINT_SCHEMA, CONSTRAINT_NAME )
              WHERE COLUMN_NAME IS NULL
                  AND CONSTRAINT_TYPE IN ('UNIQUE', 'PRIMARY KEY', 'FOREIGN KEY') ) );

--SELECT A INTO :A FROM OUTER Z;
--SELECT A INTO :A FROM OUTER Z,D;
SELECT A INTO :A FROM Z,D;
SELECT A INTO :A FROM Z,D;
--SELECT A INTO :A FROM Z,OUTER D;
SELECT A INTO :A FROM Z,D,E;
SELECT A INTO :A FROM B WHERE Z = D;
SELECT A INTO :A FROM B WHERE Z=D OR E=F;
SELECT A INTO :A FROM B WHERE (Z=D OR E=F) AND G=H;
SELECT A INTO :A FROM B WHERE (Z=D OR E=F) AND (G=H OR I=J);
SELECT A INTO :A FROM B WHERE NOT A=B;
SELECT A INTO :A FROM B WHERE NOT A=B OR Z=D;
SELECT A INTO :A FROM B WHERE NOT (A=B OR Z=D);
SELECT A INTO :A FROM B WHERE ((A+B)*Z > 5 AND G=H);
SELECT A INTO :A FROM B WHERE ((A+B)*Z > 5 OR G=H) AND I=J;
SELECT A INTO :A FROM B WHERE ((A+B)*Z > 5 OR G=H) AND (I=J);
SELECT A INTO :A FROM B WHERE ((A+B)*Z > 5 OR G=H) AND (I=J OR K=L);
SELECT A INTO :A FROM B WHERE ((A+B)*Z > 5 OR G=H) AND ((A+B)*Z < 3);
SELECT A INTO :A FROM B WHERE NOT A=B;
SELECT A INTO :A FROM B WHERE NOT (A=B OR Z=D);
SELECT A INTO :A FROM B WHERE (NOT A=B) OR NOT (Z=D OR H=G);
SELECT A INTO :A FROM B GROUP BY A;
SELECT A INTO :A FROM B WHERE A = B GROUP BY Z;
SELECT A INTO :A FROM B GROUP BY A,B,Z;
SELECT A INTO :A FROM B HAVING Z = D;
SELECT A INTO :A FROM B WHERE ((A+B)*Z > 3) HAVING Z = D;
--SELECT A INTO :A FROM B WHERE A=B GROUP BY 1 HAVING Z = D;
SELECT A INTO :A FROM B HAVING Z=D OR E=F;
SELECT A INTO :A FROM B HAVING (Z=D OR E=F) AND G=H;
SELECT A INTO :A FROM B HAVING (Z=D OR E=F) AND (G=H OR I=J);
SELECT A INTO :A FROM B HAVING NOT A=B;
SELECT A INTO :A FROM B HAVING NOT A=B OR Z=D;
SELECT A INTO :A FROM B HAVING NOT (A=B OR Z=D);
SELECT A INTO :A FROM B HAVING ((A+B)*Z > 5 AND G=H);
SELECT A INTO :A FROM B HAVING ((A+B)*Z > 5 OR G=H) AND I=J;
SELECT A INTO :A FROM B HAVING ((A+B)*Z > 5 OR G=H) AND (I=J);
SELECT A INTO :A FROM B HAVING ((A+B)*Z > 5 OR G=H) AND (I=J OR K=L);
SELECT A INTO :A FROM B HAVING NOT A=B;
SELECT A INTO :A FROM B HAVING NOT (A=B OR Z=D);
SELECT A INTO :A FROM B HAVING (NOT A=B) OR NOT (Z=D OR H=G);
--SELECT A INTO :A FROM B UNION SELECT Z FROM D;
--SELECT A INTO :A FROM B UNION ALL SELECT Z FROM D;
SELECT A INTO :A FROM B WHERE Z =D;
SELECT A INTO :A FROM B WHERE Z<>D;
SELECT A INTO :A FROM B WHERE Z<D;
SELECT A INTO :A FROM B WHERE Z<=D;
SELECT A INTO :A FROM B WHERE Z>D;
SELECT A INTO :A FROM B WHERE Z>=D;
SELECT A INTO :A FROM B WHERE A BETWEEN Z AND D;
SELECT A INTO :A FROM B WHERE A NOT BETWEEN Z AND D;
SELECT A INTO :A FROM B WHERE (A IN (B,Z,D));
SELECT A INTO :A FROM B WHERE (A NOT IN (B,Z,D));
SELECT A INTO :A FROM B WHERE (A IN (SELECT Z FROM D));
SELECT A INTO :A FROM B WHERE (A NOT IN (SELECT Z FROM D));
SELECT A INTO :A FROM B WHERE A IS NULL;
SELECT A INTO :A FROM B WHERE A IS NOT NULL;
SELECT A INTO :A FROM B WHERE (A > (SELECT B FROM Z));
SELECT A INTO :A FROM B WHERE (A < ALL (SELECT B FROM Z));
SELECT A INTO :A FROM B WHERE (A <= ANY (SELECT B FROM Z));
SELECT A INTO :A FROM B WHERE (A >= SOME (SELECT B FROM Z));
SELECT A INTO :A FROM B WHERE (EXISTS (SELECT B FROM Z));
SELECT A INTO :A FROM B WHERE (NOT EXISTS (SELECT B FROM Z));
--SELECT CURRENT, CURRENT DAY TO YEAR, DATE, DATE(A), DAY(A), EXTEND(A), EXTEND(A,DAY TO YEAR), LENGTH(A), MDY(A,B,Z), MONTH(A), TODAY, 5 UNITS YEAR, USER, WEEKDAY(A), YEAR(A) INTO :A FROM B;
--SELECT AVG(A), COUNT(A), MAX(A), MIN(A), SUM(A) INTO :A FROM B;
--SELECT AVG(DISTINCT A), COUNT(UNIQUE A), MAX(ALL A), MIN(DISTINCT A), SUM(UNIQUE A) INTO :A FROM B;
SELECT * INTO :A FROM B;
SELECT A.* INTO :A FROM B;
SELECT COUNT(*) INTO :A FROM B;
SELECT AVG((A+B)*Z) INTO :A FROM B;
--SELECT A + 5 UNITS DAY INTO :A FROM B;
--SELECT A INTO :A FROM B WHERE A - B > 30 UNITS DAY;
--SELECT DATETIME (89-8-16 14:26:0.345) YEAR TO FRACTION(3) INTO :A FROM B;
SELECT -3 * 5 + 2 INTO :A FROM B;
--SELECT UNIQUE (A) INTO :A FROM B;
DECLARE C CURSOR FOR SELECT A FROM B;
}

  return 0;

}  // main()
